package autosfx;

import javafx.animation.AnimationTimer;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;

public class AntCanvas extends Canvas {

    private static final int w = 800;
    private static final int h = 800;
    private static final int liczbaPol = 100;
    private static final int ap = liczbaPol / 2;
    private static final int szer = 8;
    private static final int len = szer * liczbaPol;
    private static final Color CW = Color.WHITE;
    private static final Color CB = Color.BLACK;
    private static final Color CR = Color.RED;
    private int[][] autos1;//komorki aktualne
    private int[][] autos2;//komorki nastepnej generacji
    private int antx;
    private int anty;
    private int antDir;
    private final AnimationTimer timer;
    private final GraphicsContext gc;

    public AntCanvas(int milis) {
        this.prefWidth(w);
        this.prefHeight(h);
        this.setWidth(w);
        this.setHeight(h);
        autos1 = new int[liczbaPol][liczbaPol];
        autos2 = new int[liczbaPol][liczbaPol];
        clear();
        antx = ap;//25
        anty = ap;//25
        antDir = 1;
        gc = this.getGraphicsContext2D();
        timer = new AntTimer();
        timer.start();
    }

    public AnimationTimer getTimer() {
        return timer;
    }

    public void clear() {
        for (int j = 0; j < liczbaPol; j++) {
            for (int k = 0; k < liczbaPol; k++) {
                this.autos1[j][k] = 0;
                this.autos2[j][k] = 0;
            }
        }
    }

    public static int changeDir(int dir, int col) {
        int newDir = 0;
        switch (dir) {
            case 1:
                if (col == 0) {
                    newDir = 2;
                } else if (col == 1) {
                    newDir = 4;
                }
                break;
            case 2:
                if (col == 0) {
                    newDir = 3;
                } else if (col == 1) {
                    newDir = 1;
                }
                break;
            case 3:
                if (col == 0) {
                    newDir = 4;
                } else if (col == 1) {
                    newDir = 2;
                }
                break;
            case 4:
                if (col == 0) {
                    newDir = 1;
                } else if (col == 1) {
                    newDir = 3;
                }
                break;
        }
        return newDir;
    }

    public void putStructure(int x, int y, int[][] array) {
        clear();
        for (int i = 0; i < array.length; i++) {
            System.arraycopy(array[i], 0, this.autos1[i + y], x, array[0].length);
        }
    }

    class AntTimer extends AnimationTimer {
        @Override
        public void handle(long now) {
            autos2 = AutosUtil.clone(autos1);
            antDir = changeDir(antDir, autos2[antx][anty]);
            if (autos2[antx][anty] == 0) {
                autos2[antx][anty]++;
            } else if (autos2[antx][anty] == 1) {
                autos2[antx][anty]--;
            }
            if (antDir == 1) {
                anty--;
                if (anty == -1) {
                    anty = liczbaPol - 1;
                }
            } else if (antDir == 2) {
                antx--;
                if (antx == -1) {
                    antx = liczbaPol - 1;
                }
            } else if (antDir == 3) {
                anty++;
                if (anty == liczbaPol) {
                    anty = 0;
                }
            } else if (antDir == 4) {
                antx++;
                if (antx == liczbaPol) {
                    antx = 0;
                }
            }
            autos1 = AutosUtil.clone(autos2);
            paint(gc);
        }
    }

    public void paint(GraphicsContext gc) {
        gc.clearRect(0, 0, w, h);
        gc.setFill(CW);
        gc.fillRect(0, 0, w, h);
        gc.setStroke(Color.rgb(200, 200, 200));
        int z = 0;//polozenie linii
        for (int i = 0; i <= liczbaPol + 1; i++) {
            gc.strokeLine(0, z, len, z);
            gc.strokeLine(z, 0, z, len);
            z += szer;
        }
        gc.setFill(CB);
        for (int i = 0; i < liczbaPol; i++) {
            for (int j = 0; j < liczbaPol; j++) {
                int x = i * szer;
                int y = j * szer;
                if (autos1[i][j] == 1) {
                    gc.fillRect(x, y, szer - 1, szer - 1);
                }
                gc.setFill(CR);
                gc.fillOval(antx * szer, anty * szer, szer - 1, szer - 1);
                gc.setFill(CB);
            }
        }
    }
}
