package autosfx;

import javafx.animation.AnimationTimer;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;

import java.util.Random;

public class NSCanvas extends Canvas {
    private static final int w = 800;
    private static final int h = 800;
    private static final int liczbaPol = 100;
    private static final int szer = 8;
    private static final int len = szer * liczbaPol;
    private static final int params = 2;//predkosc, kolor
    private int[][] autos1;//komorki aktualne
    private int[][] autos2;//komorki nastepnej generacji
    private final int milis;
    private final AnimationTimer timer;
    private final GraphicsContext gc;

    public NSCanvas(int milis) {
        this.milis = milis;
        this.prefWidth(w);
        this.prefHeight(h);
        this.setWidth(w);
        this.setHeight(h);
        autos1 = new int[liczbaPol][params];
        autos2 = new int[liczbaPol][params];
        clear();
        gc = this.getGraphicsContext2D();
        timer = new NSTimer();
        timer.start();
    }
    public AnimationTimer getTimer() {
        return timer;
    }
    class NSTimer extends AnimationTimer {
        //przegladamy wszystkie komorki zaczynajac od ostatniej
        //sprawdzamy czy komorka jest zajeta czy nie
        //jesli tak zapisujemy predkosc
        //sprawdzamy liczbe pustych kratek przed samochodem
        //czyli odleglosc od poprzedzającego samochodu
        //jesli kratka jest wolna
        //zwiekszamy dystans
        //jesli jest zajeta - przerywamy zliczanie
        //dystansu
        //jesli samochod ma zbyt duza szybkosc w stosunku
        //do odleglosci - zmniejszamy szybkosc
        //albo jesli samochod ma wolna odleglosc, a nie
        //ma maksynmalnej szybkosc - podnosimy szybkosc 0 1
        //wprowadzamy czynnik rozpraszający kierowcę
        //co powoduje hamowanie
        //jesli szybkosc jest wieksza od zero
        //przestawiamy samochod do przodu
        //indeks komórki tablicy zawierającej ostatni samochód;
        //jeśli w tablicy nie ma zadnego samochodu indeks bedzie
        //mial wartosc 100;
        //jesli w pierwszej komorce od lewej nie ma samochodu
        //
        //int s = Math.min(index, 5);
        //System.out.println(index + " " + s + " " + c);
        //-
        @Override
        public void handle(long now) {
            autos2 = AutosUtil.clone(autos1);
            //przegladamy wszystkie komorki zaczynajac od ostatniej
            for (int i = liczbaPol - 1; i >= 0; i--) {
                int speed;
                int dist = 0;
                //sprawdzamy czy komorka jest zajeta czy nie
                if (autos2[i][0] != -1) {
                    //jesli tak zapisujemy predkosc
                    speed = autos2[i][0];
                    //sprawdzamy liczbe pustych kratek przed samochodem
                    //czyli odleglosc od poprzedzającego samochodu
                    for (int j = i + 1; j < liczbaPol; j++) {
                        //jesli kratka jest wolna
                        if (autos2[j][0] == -1) {
                            //zwiekszamy dystans
                            dist++;
                        }
                        //jesli jest zajeta - przerywamy zliczanie
                        //dystansu
                        else {
                            break;
                        }
                    }
                    //jesli samochod ma zbyt duza szybkosc w stosunku
                    //do odleglosci - zmniejszamy szybkosc
                    if (dist < speed) {
                        speed = dist;
                    }
                    //albo jesli samochod ma wolna odleglosc, a nie
                    //ma maksynmalnej szybkosc - podnosimy szybkosc 0 1
                    else if ((dist > speed) && (speed < 5)) {
                        speed++;
                    }
                    //wprowadzamy czynnik rozpraszający kierowcę
                    //co powoduje hamowanie
                    Random rand = new Random();
                    float rand1 = rand.nextFloat();
                    if (rand1 < 0.3) {
                        if (speed > 0) {
                            speed--;
                        }
                    }
                    //jesli szybkosc jest wieksza od zero
                    //przestawiamy samochod do przodu
                    if ((speed > 0) && (i + speed < 99)) {
                        autos2[i + speed][0] = speed;
                        autos2[i + speed][1] = autos2[i][1];
                    }
                    autos2[i][0] = -1;
                    autos2[i][1] = -1;
                    try {
                        Thread.sleep(milis);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            }
            //indeks komórki tablicy zawierającej ostatni samochód;
            //jeśli w tablicy nie ma zadnego samochodu indeks bedzie
            //mial wartosc 100;
            int index = 100;
            for (int m = 0; m < liczbaPol; m++) {
                if (autos2[m][0] != -1) {
                    index = m;
                    break;
                }
            }
            //jesli w pierwszej komorce od lewej nie ma samochodu
            Random random = new Random();
            if (index > 0) {
                double x = random.nextDouble();
                if (x < 0.7) {
                    //
                    //int s = Math.min(index, 5);
                    int s = 1;
                    int c = AutosUtil.randomInRange(0, 9);
                    autos2[0][0] = s;
                    autos2[0][1] = c;
                    //System.out.println(index + " " + s + " " + c);
                }
            }
            //-
            autos1 = AutosUtil.clone(autos2);
            paint(gc);
        }
    }

    public void clear() {
        for (int j = 0; j < liczbaPol; j++) {
            for (int k = 0; k < params; k++) {
                this.autos1[j][k] = -1;
                this.autos2[j][k] = -1;
            }
        }
    }
    public void paint(GraphicsContext gc){
        gc.clearRect(0, 0, w, h);
        gc.setFill(Color.WHITE);
        gc.fillRect(0, 0, w, h);
        gc.setStroke(Color.LIGHTGRAY);
        int z = 0;
        gc.strokeLine(0, len / 2.0, len, len / 2.0);
        gc.strokeLine(0, szer + len / 2.0, len, szer + len / 2.0);
        for (int i = 0; i <= liczbaPol + 1; i++) {
            gc.strokeLine(z, len / 2.0, z, szer + len / 2.0);
            z += szer;
        }
        for (int i = 0; i < liczbaPol; i++) {
            if (autos1[i][1] > -1) {
                gc.setFill(AutosUtil.kolorySamochodow[autos1[i][1]]);
                gc.fillRect(1 + i * szer, 2 + len / 2.0, szer - 2, szer / 2.0);
            }
        }
        gc.setFill(Color.BLACK);
        for (int i = 0; i < liczbaPol; i++) {
            if (autos1[i][0] > -1) {
                gc.fillText("" + autos1[i][0], 1 + i * szer, -5 + len / 2.0);
            }
        }
    }
}
